/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   clocked_seq.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CLOCKED_SEQ_H
#define UHDM_CLOCKED_SEQ_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>

#include "sequence_expr_group.h"


namespace UHDM {
class expr;

class clocked_seq final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(clocked_seq, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: clocked_seq();
  virtual ~clocked_seq() final = default;

  expr* VpiClockingEvent()  { return vpiClockingEvent_; }
  const expr* VpiClockingEvent() const { return vpiClockingEvent_; }
  template <typename T>
  T* VpiClockingEvent() {
    return (vpiClockingEvent_ == nullptr) ? nullptr : any_cast<T*>(vpiClockingEvent_);
  }
  template <typename T>
  const T* VpiClockingEvent() const {
    return (vpiClockingEvent_ == nullptr) ? nullptr : any_cast<const T*>(vpiClockingEvent_);
  }
  bool VpiClockingEvent(expr* data) {
    vpiClockingEvent_ = data;
    return true;
  }

  any* VpiSequenceExpr()  { return vpiSequenceExpr_; }
  const any* VpiSequenceExpr() const { return vpiSequenceExpr_; }
  template <typename T>
  T* VpiSequenceExpr() {
    return (vpiSequenceExpr_ == nullptr) ? nullptr : any_cast<T*>(vpiSequenceExpr_);
  }
  template <typename T>
  const T* VpiSequenceExpr() const {
    return (vpiSequenceExpr_ == nullptr) ? nullptr : any_cast<const T*>(vpiSequenceExpr_);
  }
  bool VpiSequenceExpr(any* data) {
    if (!sequence_expr_groupGroupCompliant(data)) return false;
    vpiSequenceExpr_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiClockedSeq; }

  virtual clocked_seq* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmclocked_seq; }

protected:
  void DeepCopy(clocked_seq* clone, BaseClass* parent, CloneContext* context) const;

private:
  expr* vpiClockingEvent_ = nullptr;

  any* vpiSequenceExpr_ = nullptr;
};


typedef FactoryT<clocked_seq> clocked_seqFactory;


typedef FactoryT<std::vector<clocked_seq *>> VectorOfclocked_seqFactory;

}  // namespace UHDM

#endif
