/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   distribution.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_DISTRIBUTION_H
#define UHDM_DISTRIBUTION_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/constraint_expr.h>




namespace UHDM {
class expr;

class distribution final : public constraint_expr {
  UHDM_IMPLEMENT_RTTI(distribution, constraint_expr)
public:
  // Implicit constructor used to initialize all members,
  // comment: distribution();
  virtual ~distribution() final = default;

  bool VpiSoft() const { return vpiSoft_; }
  bool VpiSoft(bool data) {
    vpiSoft_ = data;
    return true;
  }

  VectorOfdist_item* Dist_items() const { return dist_items_; }
  bool Dist_items(VectorOfdist_item* data) {
    dist_items_ = data;
    return true;
  }

  expr* Expr()  { return expr_; }
  const expr* Expr() const { return expr_; }
  template <typename T>
  T* Expr() {
    return (expr_ == nullptr) ? nullptr : any_cast<T*>(expr_);
  }
  template <typename T>
  const T* Expr() const {
    return (expr_ == nullptr) ? nullptr : any_cast<const T*>(expr_);
  }
  bool Expr(expr* data) {
    expr_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiDistribution; }

  virtual distribution* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmdistribution; }

protected:
  void DeepCopy(distribution* clone, BaseClass* parent, CloneContext* context) const;

private:
  bool vpiSoft_ = false;

  VectorOfdist_item* dist_items_ = nullptr;

  expr* expr_ = nullptr;
};


typedef FactoryT<distribution> distributionFactory;


typedef FactoryT<std::vector<distribution *>> VectorOfdistributionFactory;

}  // namespace UHDM

#endif
