/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   ordered_wait.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_ORDERED_WAIT_H
#define UHDM_ORDERED_WAIT_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/waits.h>

#include "expr_sequence_inst_group.h"
#include "stmt.h"


namespace UHDM {


class ordered_wait final : public waits {
  UHDM_IMPLEMENT_RTTI(ordered_wait, waits)
public:
  // Implicit constructor used to initialize all members,
  // comment: ordered_wait();
  virtual ~ordered_wait() final = default;

  VectorOfany* VpiConditions() const { return vpiConditions_; }
  bool VpiConditions(VectorOfany* data) {
    if (!expr_sequence_inst_groupGroupCompliant(data)) return false;
    vpiConditions_ = data;
    return true;
  }

  any* VpiElseStmt()  { return vpiElseStmt_; }
  const any* VpiElseStmt() const { return vpiElseStmt_; }
  template <typename T>
  T* VpiElseStmt() {
    return (vpiElseStmt_ == nullptr) ? nullptr : any_cast<T*>(vpiElseStmt_);
  }
  template <typename T>
  const T* VpiElseStmt() const {
    return (vpiElseStmt_ == nullptr) ? nullptr : any_cast<const T*>(vpiElseStmt_);
  }
  bool VpiElseStmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    vpiElseStmt_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiOrderedWait; }

  virtual ordered_wait* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmordered_wait; }

protected:
  void DeepCopy(ordered_wait* clone, BaseClass* parent, CloneContext* context) const;

private:
  VectorOfany* vpiConditions_ = nullptr;

  any* vpiElseStmt_ = nullptr;
};


typedef FactoryT<ordered_wait> ordered_waitFactory;


typedef FactoryT<std::vector<ordered_wait *>> VectorOfordered_waitFactory;

}  // namespace UHDM

#endif
