/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   tchk_term.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TCHK_TERM_H
#define UHDM_TCHK_TERM_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class expr;

class tchk_term final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(tchk_term, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: tchk_term();
  virtual ~tchk_term() final = default;

  expr* Expr()  { return expr_; }
  const expr* Expr() const { return expr_; }
  template <typename T>
  T* Expr() {
    return (expr_ == nullptr) ? nullptr : any_cast<T*>(expr_);
  }
  template <typename T>
  const T* Expr() const {
    return (expr_ == nullptr) ? nullptr : any_cast<const T*>(expr_);
  }
  bool Expr(expr* data) {
    expr_ = data;
    return true;
  }

  expr* Condition()  { return condition_; }
  const expr* Condition() const { return condition_; }
  template <typename T>
  T* Condition() {
    return (condition_ == nullptr) ? nullptr : any_cast<T*>(condition_);
  }
  template <typename T>
  const T* Condition() const {
    return (condition_ == nullptr) ? nullptr : any_cast<const T*>(condition_);
  }
  bool Condition(expr* data) {
    condition_ = data;
    return true;
  }

  int32_t VpiEdge() const { return vpiEdge_; }
  bool VpiEdge(int32_t data) {
    vpiEdge_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiTchkTerm; }

  virtual tchk_term* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmtchk_term; }

protected:
  void DeepCopy(tchk_term* clone, BaseClass* parent, CloneContext* context) const;

private:
  expr* expr_ = nullptr;

  expr* condition_ = nullptr;

  int32_t vpiEdge_ = 0;
};


typedef FactoryT<tchk_term> tchk_termFactory;


typedef FactoryT<std::vector<tchk_term *>> VectorOftchk_termFactory;

}  // namespace UHDM

#endif
